//----------------------------------------------------------------------------
//	SOURCE:	FFcom.c
//	AUTHOR:	Ian Taylor - chilliant.com
//	NOTES:	Flag Factory 16-bit COM C entry point
//----------------------------------------------------------------------------

#include "FF.h"

int FFcom(FFfar FFpsp, FFfar FFenv)
{
	// Called from 'FF.asm'
	FFfar arg0, arg1;
	u8 FF_FAR* cmd;

	// Argument zero (executable name) comes from after the environment block
	arg0 = FFenv;
	while (arg0[0] || arg0[1])
	{
		arg0++;
	}
	arg0 += 4;

	// Argument one (command-line parameter) comes from after the PSP block
	cmd = (u8 FF_FAR*)(FFpsp + 0x81);
	cmd[cmd[-1]] = '\0';
	arg1 = (FFfar)cmd;
	while (*arg1 == ' ')
	{
		arg1++;
	}
	if (*arg1 == '\0')
	{
		arg1 = NULL;
	}
	return FFmain(arg0, arg1);
}
