//----------------------------------------------------------------------------
//	SOURCE:	FFcrt.c
//	AUTHOR:	Ian Taylor - chilliant.com
//	NOTES:	Flag Factory 16-bit minimal C runtime library replacement
//----------------------------------------------------------------------------

#include "FF.h"

#if FF_DMC

int _fltused;

void putch(char chr)
{
	__asm
	{
		mov ah, 0x02
		mov dl, chr
		int 0x21
	}
}

#endif

#if FF_OWC

void _putch(char chr)
{
	__asm
	{
		mov ah, 0x02
		mov dl, chr
		int 0x21
	}
}

#endif

s16 FFs16(fp x)
{
	s32 y;
#if FF_OWC
	y = (s32)x;
#else
	static const u16 control_word = 0x0E7F;
	__asm
	{
		fldcw	control_word
		fld		x
		fistp	y
	}
#endif
	ASSERT(y == (s32)x);
	ASSERT((y >= -0x7FFF) && (y <= 0x7FFF));
	return (s16)y;
}
