//----------------------------------------------------------------------------
//	SOURCE:	FFexe.c
//	AUTHOR:	Ian Taylor - chilliant.com
//	NOTES:	Flag Factory EXE entry point
//----------------------------------------------------------------------------

#include "FF.h"

#if FF_EXE

#pragma warning(disable: 4255 4668 4820)
#define WIN32_LEAN_AND_MEAN
#define STRICT
#include <windows.h>

int FFexe(void)
{
	LPSTR arg0 = GetCommandLineA();
	LPSTR arg1 = arg0;
	LPSTR end;
	int quote = 0;
	while (*arg1 && (quote || (*arg1 > ' ')))
	{
		quote ^= (*(arg1++) == '"');
	}
	end = arg1;
	while (*arg1 && (*arg1 <= ' '))
	{
		arg1++;
	}
	*end = '\0';
	if (*arg1 == '\0')
	{
		arg1 = NULL;
	}
	FFmain(arg0, arg1);
	return 0;
}

int _fltused;

void __cdecl _putch(char chr)
{
	DWORD written;
	WriteFile(GetStdHandle(STD_OUTPUT_HANDLE), &chr, 1, &written, NULL);
}

#else

int main(const int argc, const char* const argv[])
{
    const char* arg0 = argv[0];
    const char* arg1 = (argc > 1) ? argv[1] : NULL;
    int retval;
	retval = FFmain(arg0, arg1);
#if !FF_FINAL
	FFredirect(NULL);
#endif
	return retval;
}

#endif
